#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		subver		%(echo %{version} | cut -d '.' -f1,2)
%define		sname		%(echo %{name} | cut -d '-' -f1)
%bcond		compat		1
%if %{with compat}
#build ffmpeg in compatible (with other other ffmpeg version) mode
%define		appdir		/%{sname}%{subver}
%else
#build ffmpeg in standard mode
%define		appdir		%(echo)
%endif
#-----------------------------------------------------------------------------
Name		:	ffmpeg-4
Version		:	4.4.4
Release		:	14.8.0.0%{?dist}
Summary		:	A collection of libraries and tools to process multimedia content
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPL
URL		:	http://ffmpeg.org/releases

Source0		:	%{sname}-%{version}.tar.xz
Patch1		:	%{sname}-%{version}-binutils_2.41-1.patch

#-----------------------------------------------------------------------------
BuildRequires	:	SDL2
BuildRequires	:	fdk-aac
BuildRequires	:	freetype-devel
BuildRequires	:	lame
BuildRequires	:	libass
BuildRequires	:	libtheora
BuildRequires	:	libvorbis
BuildRequires	:	libva
BuildRequires	:	libvdpau
BuildRequires	:	libvpx
BuildRequires	:	opus-devel
BuildRequires	:	openh264
BuildRequires	:	nasm
BuildRequires	:	x264
BuildRequires	:	x265

#-----------------------------------------------------------------------------
%description
FFmpeg is a solution to record, convert and stream audio and video.
It is a very fast video and audio converter and it can also acquire
from a live audio/video source. Designed to be intuitive, the
command-line interface (ffmpeg) tries to figure out all the parameters,
when possible. FFmpeg can also convert from any sample rate to any
other, and resize video on the fly with a high quality polyphase filter.
FFmpeg can use a Video4Linux compatible video source and any Open
Sound System audio source.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%if %{with compat}
%{_sysconfdir}/ld.so.conf.d%{appdir}.conf
%endif
%doc COPYING.LGPLv3 LICENSE.md README.md RELEASE
%{_libdir}%{appdir}/lib*.so.*

#=============================================================================
%package		devel
Summary		:	Headers and libraries for the ffmpeg-4 library
	
#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
This package contains header files and
development libraries needed to develop
applications using the ffmpeg-4 library.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}%{appdir}/lib*/*h
%{_libdir}%{appdir}/lib*.so
%{_libdir}/pkgconfig%{appdir}/lib*.pc

#=============================================================================
%package		tools
Summary		:	Utilities to be use with %{name}
	
#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

conflicts	:	%{sname}-tools

#-----------------------------------------------------------------------------
%description		tools
This package contains binaries and manual to
be used with libraries %{name}

#-----------------------------------------------------------------------------
%files			tools
%defattr(-,root,root,-)
%{_bindir}/%{sname}
%{_bindir}/ffprobe
%{_bindir}/ffplay
%{_datadir}/%{sname}/examples/*
%{_datadir}/%{sname}/ffprobe.xsd
%{_datadir}/%{sname}/libvpx*.ffpreset
%{_defaultdocdir}/%{sname}-%{version}/*.html
%{_mandir}/man1/ff*.1.gz
%{_mandir}/man3/lib*.3.gz

#=============================================================================
%prep
%setup -q  -n %{sname}-%{version}
patch -Np1 -i %{PATCH1}


#-----------------------------------------------------------------------------
#building application
%build

sed -i							\
  -e 's/-lflite"/-lflite -lasound"/'			\
  configure

./configure						\
	--prefix=%{_prefix}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}/%{appdir}			\
	--incdir=%{_includedir}/%{appdir}/		\
	--shlibdir=%{_libdir}/%{appdir}/		\
	--pkgconfigdir=%{_libdir}/pkgconfig%{appdir}/	\
	--docdir=%{_defaultdocdir}/%{sname}-%{version}/	\
	--enable-gpl					\
	--enable-version3				\
	--enable-nonfree				\
	--disable-static				\
	--enable-shared					\
	--disable-debug					\
	--enable-libass					\
	--enable-libfdk-aac				\
	--enable-libfreetype				\
	--enable-libmp3lame				\
	--enable-libopus				\
	--enable-libtheora				\
	--enable-libvorbis				\
	--enable-libvpx					\
	--enable-vaapi					\
	--enable-vdpau					\
	--enable-libx264				\
	--enable-libx265				\
	--enable-libopenh264				\
	--enable-openssl				\
	--disable-stripping 				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

%if %{with compat}
#Adjusting load search when linking
%{__mkdir_p} %{buildroot}%{_sysconfdir}/ld.so.conf.d/
(
echo "%{_libdir}%{appdir}"
) > %{buildroot}%{_sysconfdir}/ld.so.conf.d%{appdir}.conf
%endif

#-----------------------------------------------------------------------------
%changelog
